searchNodes=[{"doc":"New Relic Agent - Public API","ref":"NewRelic.html","title":"NewRelic","type":"module"},{"doc":"Report custom attributes on the current TransactionReporting nested data structures is supported by auto-flattening them into a list of key-value pairs.NewRelic.add_attributes(foo: &quot;bar&quot;) # &quot;foo&quot; =&gt; &quot;bar&quot; NewRelic.add_attributes(map: %{foo: &quot;bar&quot;, baz: &quot;qux&quot;}) # &quot;map.foo&quot; =&gt; &quot;bar&quot; # &quot;map.baz&quot; =&gt; &quot;qux&quot; # &quot;map.size&quot; =&gt; 2 NewRelic.add_attributes(list: [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;]) # &quot;list.0&quot; =&gt; &quot;a&quot; # &quot;list.1&quot; =&gt; &quot;b&quot; # &quot;list.2&quot; =&gt; &quot;c&quot; # &quot;list.length&quot; =&gt; 3Notes:Nested Lists and Maps are truncated at 10 items since there are a limited number of attributes that can be reported on Transaction events","ref":"NewRelic.html#add_attributes/1","title":"NewRelic.add_attributes/1","type":"function"},{"doc":"Advanced: Call to manually connect the current process to another process's Transaction.Only use this when there is no discoverable connection (ex: the process was spawned without links or the logic is within a message handling callback).This connection will persist until the process exits or NewRelic.disconnect_from_transaction() is called.","ref":"NewRelic.html#connect_to_transaction/1","title":"NewRelic.connect_to_transaction/1","type":"function"},{"doc":"See NewRelic.DistributedTrace.distributed_trace_headers/1.","ref":"NewRelic.html#create_distributed_trace_payload/1","title":"NewRelic.create_distributed_trace_payload/1","type":"function"},{"doc":"Advanced: Call to manually disconnect the current proccess from the current Transaction.","ref":"NewRelic.html#disconnect_from_transaction/0","title":"NewRelic.disconnect_from_transaction/0","type":"function"},{"doc":"You must manually instrument outgoing HTTP calls to connect them to a Distributed Trace.The agent will automatically read request headers and detect if the request is a part of a Distributed Trace, but outgoing requests need an extra header:HTTPoison.get(url, [&quot;x-api-key&quot;: &quot;secret&quot;] ++ NewRelic.distributed_trace_headers(:http))Notes:Call NewRelic.distributed_trace_headers immediately before making the request since calling the function marks the &quot;start&quot; time of the request.","ref":"NewRelic.html#distributed_trace_headers/1","title":"NewRelic.distributed_trace_headers/1","type":"function"},{"doc":"Call to exclude the current process from being part of the Transaction.","ref":"NewRelic.html#exclude_from_transaction/0","title":"NewRelic.exclude_from_transaction/0","type":"function"},{"doc":"Call within a transaction to prevent it from reporting.def index(conn, _) do NewRelic.ignore_transaction() send_resp(conn, 200, &quot;Health check OK&quot;) end","ref":"NewRelic.html#ignore_transaction/0","title":"NewRelic.ignore_transaction/0","type":"function"},{"doc":"Define an &quot;Other&quot; transaction within the given block. The return value of the block is returned.See start_transaction and stop_transaction for more details.","ref":"NewRelic.html#other_transaction/3","title":"NewRelic.other_transaction/3","type":"macro"},{"doc":"Report a Custom event to NRDB.NewRelic.report_custom_event(&quot;EventType&quot;, %{&quot;foo&quot; =&gt; &quot;bar&quot;})","ref":"NewRelic.html#report_custom_event/2","title":"NewRelic.report_custom_event/2","type":"function"},{"doc":"Report a Custom metric.NewRelic.report_custom_metric(&quot;My/Metric&quot;, 123)","ref":"NewRelic.html#report_custom_metric/2","title":"NewRelic.report_custom_metric/2","type":"function"},{"doc":"To get detailed information about a particular process, you can install a Process sampler. You must tell the Agent about your process from within the process.For a GenServer, this function call should be made in the init function:defmodule ImportantProcess do use GenServer def init(:ok) do NewRelic.sample_process {:ok, %{}} end endOnce installed, the agent will report ElixirSample events with:category = &quot;Process&quot;message_queue_lengthreductionsmemory_kb","ref":"NewRelic.html#sample_process/0","title":"NewRelic.sample_process/0","type":"function"},{"doc":"Store information about the type of work the current span is doing.Options::generic, custom: attributes:http, url: url, method: method, component: component:datastore, statement: statement, instance: instance, address: address, hostname: hostname, component: component","ref":"NewRelic.html#set_span/2","title":"NewRelic.set_span/2","type":"function"},{"doc":"Set the name of the current transaction.The first segment will be treated as the Transaction namespace, and commonly contains the name of the framework.Notes:At least 2 segments are required to light up the Transactions UI in APMIn the following example, you will see /custom/transaction/name in the Transaction list.NewRelic.set_transaction_name(&quot;/Plug/custom/transaction/name&quot;)","ref":"NewRelic.html#set_transaction_name/1","title":"NewRelic.set_transaction_name/1","type":"function"},{"doc":"Start an &quot;Other&quot; Transaction.This will begin monitoring the current process as an &quot;Other&quot; Transaction (ie: Not a &quot;Web&quot; Transaction). The first argument will be considered the &quot;category&quot;, the second is the &quot;name&quot;.Examples:NewRelic.start_transaction(&quot;GenStage&quot;, &quot;MyConsumer/EventType&quot;) NewRelic.start_transaction(&quot;Task&quot;, &quot;TaskName&quot;)Notes:Don't use this to track Web Transactions - Plug based HTTP servers are auto-instrumented based on telemetry events.Do not use this for processes that live a very long time, doing so will risk a memory leak tracking attributes in the transaction!You can't start a new transaction within an existing one. Any process spawned inside a transaction belongs to that transaction.If multiple transactions are started in the same Process, you must call NewRelic.stop_transaction() to mark the end of the transaction.","ref":"NewRelic.html#start_transaction/2","title":"NewRelic.start_transaction/2","type":"function"},{"doc":"Stop an &quot;Other&quot; Transaction.If multiple transactions are started in the same Process, you must call NewRelic.stop_transaction() to mark the end of the transaction.","ref":"NewRelic.html#stop_transaction/0","title":"NewRelic.stop_transaction/0","type":"function"},{"doc":"New Relic Agent ConfigurationAll configuration items can be set via Environment variables or via Application config","ref":"NewRelic.Config.html","title":"NewRelic.Config","type":"module"},{"doc":"RequiredConfigure your application name. May contain up to 3 names seperated by ;Application name can be configured in two ways:Environment variable: NEW_RELIC_APP_NAME=MyAppApplication config: config :new_relic_agent, app_name: &quot;MyApp&quot;","ref":"NewRelic.Config.html#app_name/0","title":"NewRelic.Config.app_name/0","type":"function"},{"doc":"An optional list of key/value pairs that will be automatic custom attributes on all event types reported (Transactions, etc). Values are determined at Agent start.Options:{:system, &quot;ENV_NAME&quot;} Read a System ENV variable{module, function, args} Call a function.&quot;foo&quot; A direct valueThis feature is only configurable with Application config.Example:config :new_relic_agent, automatic_attributes: [ environment: {:system, &quot;APP_ENV&quot;}, node_name: {Node, :self, []}, team_name: &quot;Afterlife&quot; ]","ref":"NewRelic.Config.html#automatic_attributes/0","title":"NewRelic.Config.automatic_attributes/0","type":"function"},{"doc":"Some Agent features can be controlled via configuration.Logs In ContextThis feature can be run in multiple &quot;modes&quot;:forwarder The recommended mode which formats outgoing logs as JSON objects ready to be picked up by a Log Forwarderdirect Logs are buffered in the agent and shipped directly to New Relic. Your logs will continue being output to their normal destination.disabled (default)Logs In Context can be configured in two ways:Environment variable NEW_RELIC_LOGS_IN_CONTEXT=forwarderApplication config config :new_relic_agent, logs_in_context: :forwarderInfinite TracingInfinite Tracing gives you more control of sampling by collecting 100% of Spans and sending them to a Trace Observer for processing.You can configure your Trace Observer in two ways:Environment variable NEW_RELIC_INFINITE_TRACING_TRACE_OBSERVER_HOST=trace-observer.hostApplication config config :new_relic_agent, infinite_tracing_trace_observer_host: &quot;trace-observer.host&quot;","ref":"NewRelic.Config.html#feature/1","title":"NewRelic.Config.feature/1","type":"function"},{"doc":"Some Agent features can be toggled via configuration.Security:error_collector_enabled (default true)Toggles collection of any Error traces or metrics:db_query_collection_enabled (default true)Toggles collection of Database query stringsfunction_argument_collection_enabled (default true)Toggles collection of traced function argumentsInstrumentationOpting out of Instrumentation means that :telemetry handlers will not be attached, reducing the performance impact to zero.:plug_instrumentation_enabled (default true)Controls all Plug instrumentation:ecto_instrumentation_enabled (default true)Controls all Ecto instrumentation:redix_instrumentation_enabled (default true)Controls all Redix instrumentation:request_queuing_metrics_enabledControls collection of request queuing metricsConfigurationEach of these features can be configured in two ways, for example:Environment variables: NEW_RELIC_ERROR_COLLECTOR_ENABLED=falseApplication config: config :new_relic_agent, error_collector_enabled: false","ref":"NewRelic.Config.html#feature?/1","title":"NewRelic.Config.feature?/1","type":"function"},{"doc":"An optional list of labels that will be applied to the application.Configured with a single string containing a list of key-value pairs:key1:value1;key2:value2The delimiting characters ; and : are not allowed in the key or valueLabels can be configured in two ways:Environment variables: NEW_RELIC_LABELS=region:west;env:prodApplication config: config :new_relic_agent, labels: &quot;region:west;env:prod&quot;","ref":"NewRelic.Config.html#labels/0","title":"NewRelic.Config.labels/0","type":"function"},{"doc":"RequiredConfigure your New Relic License Key.License Key can be configured in two ways, though using Environment Variables is strongly recommended to keep secrets out of source code:Environment variables: NEW_RELIC_LICENSE_KEY=abc123Application config: config :new_relic_agent, license_key: &quot;abc123&quot;","ref":"NewRelic.Config.html#license_key/0","title":"NewRelic.Config.license_key/0","type":"function"},{"doc":"Configure the Agent logging mechanism.This controls how the Agent logs it's own behavior, and doesn't impact your applications own logging at all.Defaults to the File &quot;tmp/new_relic.log&quot;.Options:&quot;stdout&quot; Write directly to Standard Out&quot;Logger&quot; Send Agent logs to Elixir's Logger&quot;file_name.log&quot; Write to a chosen fileAgent logging can be configured in two ways:Environment variable: NEW_RELIC_LOG=stdoutApplication config: config :new_relic_agent, log: &quot;stdout&quot;","ref":"NewRelic.Config.html#logger/0","title":"NewRelic.Config.logger/0","type":"function"},{"doc":"","ref":"NewRelic.Instrumented.Mix.Task.html","title":"NewRelic.Instrumented.Mix.Task","type":"module"},{"doc":"Provides Ecto instrumentation via telemetry.Repos are auto-discovered and instrumented. Make sure your Ecto app depends on new_relic_agent so that the agent can detect when your Repos start.We automatically gather:Datastore metricsTransaction Trace segmentsTransaction datastore attributesDistributed Trace span eventsYou can opt-out of this instrumentation as a whole and specifically of SQL query collection via configuration. See NewRelic.Config for details.","ref":"NewRelic.Telemetry.Ecto.html","title":"NewRelic.Telemetry.Ecto","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"NewRelic.Telemetry.Ecto.html#child_spec/1","title":"NewRelic.Telemetry.Ecto.child_spec/1","type":"function"},{"doc":"Provides Phoenix instrumentation via telemetry.This instrumentation adds extra Phoenix specific instrumentation on top of the base NewRelic.Telemetry.Plug instrumentation.","ref":"NewRelic.Telemetry.Phoenix.html","title":"NewRelic.Telemetry.Phoenix","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"NewRelic.Telemetry.Phoenix.html#child_spec/1","title":"NewRelic.Telemetry.Phoenix.child_spec/1","type":"function"},{"doc":"","ref":"NewRelic.Telemetry.Phoenix.html#handle_event/4","title":"NewRelic.Telemetry.Phoenix.handle_event/4","type":"function"},{"doc":"","ref":"NewRelic.Telemetry.Phoenix.html#start_link/1","title":"NewRelic.Telemetry.Phoenix.start_link/1","type":"function"},{"doc":"Provides Plug instrumentation via telemetry.Plug pipelines are auto-discovered and instrumented.We automatically gather:Transaction metrics and eventsTransaction TracesDistributed TracesYou can opt-out of this instrumentation via configuration. See NewRelic.Config for details.To prevent reporting an individual transaction:NewRelic.ignore_transaction()Inside a Transaction, the agent will track work across processes that are spawned. You can signal to the agent not to track work done inside a spawned process, which will exclude it from the current Transaction.To exclude a process from the Transaction:Task.async(fn -&gt; NewRelic.exclude_from_transaction() Work.wont_be_tracked() end)","ref":"NewRelic.Telemetry.Plug.html","title":"NewRelic.Telemetry.Plug","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"NewRelic.Telemetry.Plug.html#child_spec/1","title":"NewRelic.Telemetry.Plug.child_spec/1","type":"function"},{"doc":"Provides Redix instrumentation via telemetry.Redix connections are auto-discovered and instrumented.We automatically gather:Datastore metricsTransaction Trace segmentsTransaction datastore attributesDistributed Trace span eventsYou can opt-out of this instrumentation as a whole and specifically of query collection via configuration. See NewRelic.Config for details.","ref":"NewRelic.Telemetry.Redix.html","title":"NewRelic.Telemetry.Redix","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"NewRelic.Telemetry.Redix.html#child_spec/1","title":"NewRelic.Telemetry.Redix.child_spec/1","type":"function"},{"doc":"Function TracingTo enable function tracing in a particular module, use NewRelic.Tracer, and annotate the functions you want to @trace.Traced functions will report as:Segments in Transaction TracesSpan Events in Distributed TracesSpecial custom attributes on Transaction EventsNotes:Traced functions will not be tail-call-recursive. Don't use this for recursive functions.Exampledefmodule MyModule do use NewRelic.Tracer @trace :func def func do # Will report as `MyModule.func/0` end endCategoriesTo categorize External Service calls you must give the trace annotation a category.You may also call NewRelic.set_span to provide better naming for metrics &amp; spans, and additonally annotate the outgoing HTTP headers with the Distributed Tracing context to track calls across services.defmodule MyExternalService do use NewRelic.Tracer @trace {:request, category: :external} def request(method, url, headers) do NewRelic.set_span(:http, url: url, method: method, component: &quot;HttpClient&quot;) headers ++ NewRelic.distributed_trace_headers(:http) HttpClient.request(method, url, headers) end endThis will:Post External metrics to APMAdd custom attributes to Transaction events:external_call_countexternal_duration_msexternal.MyExternalService.query.call_countexternal.MyExternalService.query.duration_msTransactions that call the traced ExternalService functions will contain external_call_count attributeget &quot;/endpoint&quot; do ExternalService.request(:get, url, headers) send_resp(conn, 200, &quot;ok&quot;) endArgumentsBy default, arguments are inspected and recorded along with traces. You can opt-out of function argument tracing on individual tracers:defmodule SecretModule do use NewRelic.Tracer @trace {:login, args: false} def login(username, password) do # do something secret... end endThis will prevent the argument values from becoming part of Transaction Traces.This may also be configured globally via Application config. See NewRelic.Config for details.","ref":"NewRelic.Tracer.html","title":"NewRelic.Tracer","type":"module"},{"doc":"New Relic's Elixir Agent The Open-Source Elixir Agent allows you to monitor your Elixir applications with New Relic. It helps you track transactions, distributed traces and other parts of your application's behavior and provides an overview of underlying BEAM activity.View the DocumentationSupport StatementNew Relic has open-sourced this project to enable monitoring of Elixir applications. This project is provided AS-IS WITHOUT WARRANTY OR SUPPORT, although you can report issues and contribute to the project here on GitHub.ContributingWe'd love to get your contributions to improve the elixir agent! Keep in mind when you submit your pull request, you'll need to sign the CLA via the click-through using CLA-Assistant. If you'd like to execute our corporate CLA, or if you have any questions, please drop us an email at open-source@newrelic.com.","ref":"readme.html","title":"New Relic's Elixir Agent","type":"extras"},{"doc":"Install the Hex packageRequirements:Erlang/OTP 21Elixir 1.8defp deps do [ {:new_relic_agent, &quot;~&gt; 1.0&quot;} ] end","ref":"readme.html#installation","title":"New Relic's Elixir Agent - Installation","type":"extras"},{"doc":"You need to set a few required configuration keys so we can authenticate properly.Via Application configconfig :new_relic_agent, app_name: &quot;My App&quot;, license_key: &quot;license_key&quot;Via Environment variablesYou can also configure these attributes via ENV vars, which helps keep secrets out of source code.NEW_RELIC_APP_NAMENEW_RELIC_LICENSE_KEY","ref":"readme.html#configuration","title":"New Relic's Elixir Agent - Configuration","type":"extras"},{"doc":"Some common Elixir packages are auto-instrumented via telemetryPlug: See NewRelic.Telemetry.Plug for details.Phoenix: See NewRelic.Telemetry.Phoenix for details.Ecto: See NewRelic.Telemetry.Ecto for details.Redix: See NewRelic.Telemetry.Redix for details.","ref":"readme.html#telemetry","title":"New Relic's Elixir Agent - Telemetry","type":"extras"},{"doc":"Function TracingNewRelic.Tracer enables detailed Function tracing. Annotate a function and it'll show up as a span in Transaction Traces / Distributed Traces, and we'll collect aggregate stats about it. Install it by adding use NewRelic.Tracer to any module, and annotating any function with @trace module attributedefmodule MyModule do use NewRelic.Tracer @trace :func def func do # Will report as `MyModule.func/0` end endDistributed TracingRequests to other services can be traced with the combination of an additional outgoing header and an :external tracer.defmodule MyExternalService do use NewRelic.Tracer @trace {:request, category: :external} def request(method, url, headers) do NewRelic.set_span(:http, url: url, method: method, component: &quot;HttpClient&quot;) headers = headers ++ NewRelic.distributed_trace_headers(:http) HttpClient.request(method, url, headers) end endPre-Instrumented ModulesNewRelic.Instrumented.Mix.Task To enable the Agent and record an Other Transaction during a Mix.Task, simply use NewRelic.Instrumented.Mix.Task. This will ensure the agent is properly started, records the Transaction, and is shut down.defmodule Mix.Tasks.Example do use Mix.Task use NewRelic.Instrumented.Mix.Task def run(args) do # ... end endNewRelic.Instrumented.HTTPoison Automatically wraps HTTP calls in a span, and adds an outbound header to track the request as part of a Distributed Trace.alias NewRelic.Instrumented.HTTPoison HTTPoison.get(&quot;http://www.example.com&quot;)Other TransactionsYou may start an &quot;Other&quot; Transaction for non-HTTP related work. This could used be while consuming from a message queue, for example.To start an other transaction:NewRelic.start_transaction(category, name)And to stop the transaction within the same process:NewRelic.stop_transaction()AdaptersThere are a few adapters which leverage this agent to provide library / framework specific instrumentation. Note that these will eventually be replaced with telemetry based instrumentation.Absinthe https://github.com/binaryseed/new_relic_absinthe","ref":"readme.html#custom-instrumentation","title":"New Relic's Elixir Agent - Custom Instrumentation","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"v1.24.0FeaturesPlug instrumentation is now fully automatic based on telemetry events!Please remove deprecated calls:use NewRelic.TransactionNewRelic.Transaction.handle_errors/2Phoenix instrumentation is not fullly automatic based on telemetry events!Please remove deprecated instrumentation library:https://github.com/binaryseed/new_relic_phoenixTransaction tracking is now faster and better in the face of overloadv1.23.0FeaturesAdds support for Infinite Tracing. #307v1.22.6TweaksAdd ERTS Version to environment values. #302v1.22.5FixesHandle formatting exit edge case. #300Work around CPU util shutdown issue. #301v1.22.4FeaturesAdds a macro for defining an Other Transaction. #264FixesHandle when a string winds up in a stacktrace list. #294Properly handle boolean config option. #295Prevent error when bad attribute values get in. #296v1.22.3TweaksMake request queuing collection configurable #292v1.22.2TweaksOptimize metric aggregation with :counterv1.22.1FixesFix a compile time warning about :scheduler #288Avoid a shutdown bug in :cpu_sup #287v1.22.0FeaturesReport a custom metric. #283v1.21.2FixesHandle encoding an unexpected nil sampled flag. #282v1.21.1FixesProperly handle a bad tracestate sampled / priority value. #273v1.21.0FeaturesLogs in context - connect Logger messages to the current Distributed Trace / Error Trace. #272Logs in context requires Elixir 1.10 or greater.v1.20.0Removals:Stop reporting redundant ElixirAggregate custom events for Transaction. #276Stop reporting redundant ElixirAggregate custom events for FunctionTrace. #277Alternatives for querying this data are available and noted in the PRs.FixesDon't warn for untraced functions. #269 Thanks @barthez!Spread the Samplers across the full sample cycle. #278v1.19.7TweaksLog the number of events seen by harvesters. #274v1.19.6FixesProperly handle bad values in Custom and Span Events. #267 &amp; #268v1.19.5FixesFix memory leak in long running transactions. #263 Thanks @mopp!v1.19.4FixesFix tracer compilation bug. #255v1.19.3FeaturesReport more Error metrics based on transaction type. #251v1.19.2TweaksOptimize memory usage in Metric harvester. #242Silence warnings in Elixir 1.10. #243v1.19.1FixesFix a regression from 1.18 with Transaction error attribute. #240v1.19.0FeaturesAutomatic Redix instrumentation based on telemetry events! #210v1.18.5FixesFix one more tracer compilation bug. #239v1.18.4FixesFix another interesting tracer compilation bug. #235v1.18.3FixesFix another tracer compilation bug. #230v1.18.2FixesFix a tracer compilation bug. #228v1.18.1TweaksReport additional Datastore metrics. #224v1.18.0FeaturesRead the Docker container ID for accurate container detection. #207 Thanks @alejandrodnm!Report Ecto queries that result in an error. #202Coerce and handle all custom attribute values. #205Mix.Task instrumentation. #221TweaksMake plug_cowboy an optional dep. #201Use Erlang/OTP 21+ built-in SSL hostname verification. #197Reduce contention on transaction storage. #209Detect Ecto repo via telemetry event instead of an Erlang tracer. #214Fix for Distributed Traces that start from a Browser Agent. #215Fix for error reporting during Other Transactions. #220 Thanks @prabello.v1.17.1FixesHandle cases where another New Relic agent sends a bad tracestate header. #206v1.17.0FeaturesReport &quot;Scoped&quot; Transaction metrics:Externals #175Function traces #189Database calls #195Enable disabling function argument tracing globally &amp; per-trace. #186Provide an API for manually stopping an Other transaction. #198v1.16.7FixesHandle Ecto stream telemetry results. #192v1.16.6FixesPrevent boot process from getting blocked if New Relic is slow. #187v1.16.5FixesFix macro compilation with Elixir 1.10. Thanks @ethangunderson! #185v1.16.4TweaksRemove ecto metadata catchall for better debugging.v1.16.3FixesFix sampling decision default value. #177v1.16.2FixesHandle error queries properly. #173v1.16.1FixesSafely access optional Ecto config attributes. #172v1.16.0FeaturesSupport the W3C Trace Context spec for Distributed Tracing. #169Upgrade to New Relic &quot;Protocol 17&quot; which includes support for faster event harvest (sent every 5 seconds!). #168v1.15.0FeaturesAdds automatic Ecto instrumentation via telemetry. #161Deprecates @trace {_, category: :datastore}. These trace annotations will now be ignored, and a warning logged during compilation.Metric name change: Datastore Metrics reported now follow New Relic naming conventions, based on the table namev1.14.0FeaturesMinor internal refactor to enable reporting spans after they complete. #160v1.13.1FixesHandle rare edge cases connecting to New Relic. #156v1.13.0FeaturesOTP 21+ has been required for a while, and now the agent will enforce this version requirement #151Truncate super large nested attribute structure #153v1.12.0FeaturesAdd support for detecting request queuing via x-request-start. #143 Thanks @sb8244!https://docs.newrelic.com/docs/apm/applications-menu/features/configure-request-queue-reportingv1.11.0FeaturesAdd support for detecting if the app is running inside Kubernetes. #140v1.10.2FixesProtect against huge arguments blowing out memory #136v1.10.1TweaksHandle lists inside objects passed to add_attributes #135 Thanks @emeryotopalik!v1.10.0FeaturesAdd an option to not track async_nolink task as part of the Transaction. #123Ignore extraneous Plug errors (ie: 400s). #125TweaksImprove formatting of ErlangError. #126v1.9.12FixesPrevent a rare harvester leak. #124v1.9.11FixesProtect against missing attribute under race condition. #120v1.9.10FixesRevert async_nolink change. #119v1.9.9FixesFix a race condition around error reporting and async_nolink #118. Thanks @zoevkay!v1.9.8FixesFix a bug causing extra spans to be reported #116v1.9.7TweaksImprove formatting for EXIT errors#112#113v1.9.5TweaksTrack CPU count. #110v1.9.4FixesFix a bug in PriorityQueue. #109 Thanks @jasondew!v1.9.3TweaksLowers the log level for harvester output. #105v1.9.2FixesFix a error that can happen if required attributes aren't captured. #103v1.9.1FixesFix the transaction event name attribute. #100v1.9.0FeaturesUse erlang's httpc client. #70Calculate and report the Total Time in a Transaction. #98FixesAttempt to flush each harvester upon graceful shutdown. #94Report External metrics based on transaction type. #99v1.8.0FeaturesEnable ignoring a Transaction. #93Track the number of processes spawned during a Transaction. #88FixesHandle error fetching AWS fargate metadata. #89Avoid a compiler warning for some traced functions. #92Prevent nested spans from duplicating attributes. #97v1.7.0Support for &quot;Other&quot; (non-web) Transactions. #84Calculate and report Apdex metric. #87v1.6.2Improve error logging when encountering a bad DT payloadv1.6.1Clear up some deprecation warnings in Elixir 1.8.0v1.6.0Add support for applying labels. #79Detect Heroku dyno hostnames. #80Provide better error structure for wrapped exceptions. #78v1.5.0More flexible datastore metric reporting in prep for Ecto instrumentation. #76v1.4.0Support nested Function Tracers in Transaction Traces and Distributed Tracing. #58v1.3.2Specify Plug and Cowboy versions via plug_cowboy package.v1.3.1Properly handle when no app name has been supplied.v1.3.0Enable the NewRelic logger to use the Elixir Logger #67Properly assign multiple app names #66.Log the collector method along with failed requests #65.v1.2.1Fix a bug that caused a subset of Span Events to be sent even though the Transaction wasn't sampled #63v1.2.0Leverage the new Erlang :logger when running OTP 21 for improved Transaction / Error connecting #55Record process memory &amp; reductions at the end of a Transaction #56v1.1.0Report as elixir. #19APM now has first-class support for Elixir! Along with this agent upgrade, you will find the BEAM stats page availble with easy access to information about the VM, including Processes, Memory and Network. See https://github.com/newrelic/elixir_agent/wiki/BEAM-stats-page for more info.Note: I haven't followed semver very well, from now on I'll be bumping the minor version for each release of new features, and reserve the patch for bugfixes.v1.0.5Report more Beam VM stats. #38, #46Report process stats for top consuming processes. #41Re-factor a few agent innards to enable transaction name and errors.v1.0.4Enable configuring Error collection via :error_collector_enabled #36 (Thanks @sb8244)v1.0.3Report basic CPU and Memory metrics #34Report caller metrics to enable relationship generationExtend the timeout waiting for data to post to New RelicAdd HTTPoison.request/5 instrumented function (Thanks @rhruiz)","ref":"changelog.html#changelog","title":"CHANGELOG - CHANGELOG","type":"extras"}]